(* Time-stamp: <modified the 07/06/2019 (at 17:38) by Erwan Jahier> *)

module Dico = Map.Make(String)

open Algo
type t = local_env Dico.t 

let (get: t -> string -> Algo.local_env) =
  fun e pid v ->
    (*     Printf.printf "get pid %s\n" pid; flush stdout; *)
    try ((Dico.find pid e) v)
    with e ->
      failwith (Printf.sprintf "Unknown value: %s.%s (%s)" pid v (Printexc.to_string e))


let (get_copy: Algo.vars -> t -> string -> Algo.local_env) =
  fun vars e pid ->
    Algo.copy_local_env vars (get e pid)


let (set: t -> string -> Algo.local_env -> t) =
  fun e pid lenv ->
    Dico.add pid lenv e

let (init:unit -> t) = fun () -> Dico.empty

