(* Time-stamp: <modified the 07/06/2019 (at 16:23) by Erwan Jahier> *)

(** There is such a Process.t per node in the dot file. *)
type t = {
  pid : string; (* unique *)
  variables : Algo.vars;
  actions: Algo.action list;
  init : Algo.local_env;
  enable : Algo.enable_fun;
  step : Algo.step_fun;
}


(* Dynamically link the algo_nodes.cmxs files (not possible from rdbg)  *)
val dynlink_nodes: string -> unit

(** [make custom_mode_flag node] builds a process out of a dot
   node. To do that, it retreives the registered functions by Dynamic
   linking of the cmxs file specified in the "algo" field of the dot
   node.

    nb: it provides variable initial values if not done in the dot
   (via the init field) nor in the Algo (via Algo.reg_init_vars) *)
val make: bool -> Topology.node -> Algo.neighbor list -> t
